PROCEDURE imp_sd_xml_update (kodas_lk)
ON error

* - Importas i kintamuju reiksmes is sodros XML failo

IF EMPTY(kodas_lk)
	MESSAGEBOX("Importo programos parametruose nenurodytas kintamojo kodas!",16,"Nenurodytas kintamojo kodas")
	RETURN .F.
ENDIF

m.laik =laik_k(PS_KOD(,"Nurodykite dat: ",laik_k(DATE()),,,"D"))

m.err_msg =""
xml_file= GETFILE("XML" ,"Pasirinkite" )

IF EMPTY(xml_file)
	RETURN .f.
ENDIF


ln_handl=fopen(xml_file)  && Open xml
If ln_handl<1
           =l_window("Nepavyko atidaryti failo "+xml_file)
           Return .f.
Endif

* - nuskaitomas visas XML failas
m.duomenys = ""
Do while !feof(ln_handl)
	lc_irasas=fgets(ln_handl,400)
	lc_irasas=STRCONV(STRCONV(lc_irasas,11,1257,1),2) &&lietuviki ramenys
	m.duomenys = m.duomenys + lc_irasas                 
ENDDO

Create Cursor kint (kodas_tb C(12), kodas_ak C(20), sod_nr C(20), procentas N(14,3), datai C(10))

DO WHILE .t.
	m.asmuo = f_xml("<Asmuo>",m.duomenys) &&imama visa informacija tarp tag'u <Asmuo>

	IF EMPTY(m.asmuo)
		EXIT
	ENDIF
	
	m.ak = f_xml("<AsmKodas>",m.asmuo)
	m.sodra_nr = ALLTRIM(f_xml("<AsmSocDrNr>",m.asmuo))
	m.sodra_nr = SUBSTR(m.sodra_nr,1,2) + ALLTRIM(STR(VAL(ALLTRIM(SUBSTR(m.sodra_nr,3,18)))))
	*m.laik = LAIK_k(CTOD(f_xml("<AsmDataNuo>",m.asmuo)))
	m.sodra = VAL(CHRTRAN(f_xml("<ApdrPkTrf>",m.asmuo),",","."))
	m.tabel = ""
	
	IF !EMPTY(m.ak)
		* - ieskomi darbuotoju tabeliniai numeriai pagal asmens koda
		f_select("SELECT a06_kodas_tb, a06_zml_iki FROM A06_tab WHERE a06_apdr_nr = ?m.ak and a06_zml_iki >= ?m.laik ","la06")
		
		IF EOF("la06")
			m.err_msg = m.err_msg + CHR(10) + "Darbuotoj srae nerastas asmens kodas " + m.ak
			m.duomenys = SUBSTR(m.duomenys,ATC("<Asmuo>",m.duomenys,2))
			LOOP
		ENDIF
		
		SELECT LA06
		GO TOP
		SCAN
			m.tabel = la06.a06_kodas_tb
			m.pap_kint = PADL(ALLTRIM(kodas_lk),12,"0")
			* - jeigu paskutine galiojanti reiksme sutampa su failo reiksme tada neimportuojama
			=f_select("SELECT a02_kodas_tb FROM a02_kinr WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint","ll02")
			
			IF EOF("ll02") AND m.sodra <> 0
				INSERT INTO kint VALUES (m.tabel, m.ak, m.sodra_nr, m.sodra, DTOC(m.laik))			
			ELSE 
				IF FZMO(VAL(kodas_lk), m.laik, m.tabel) <> m.sodra
					* - Tikrinama ar nebuvo vesta konkreciai datai, t.y. jeigu jau buvo importuota u t mnes, bet norima updatinti
					=f_select("SELECT * FROM a02_kinr WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint AND a02_date = ?m.laik","ll02_2")
					IF EOF("ll02_2")
						INSERT INTO kint VALUES (m.tabel, m.ak, m.sodra_nr, m.sodra, DTOC(m.laik))
					ELSE
						=f_select("UPDATE a02_kinr SET a02_suma = ?m.sodra WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint AND a02_date = ?m.laik")
						m.err_msg = m.err_msg + CHR(10) + "Tabeliniui " + ALLTRIM(m.tabel) + " buvo atnaujinta " + DTOC(m.laik) + " datai reikm  " + ALLTRIM(STR(m.sodra,10,2))
					ENDIF
				ENDIF
			endif
		ENDSCAN
	ELSE
		* - ieskomi darbuotoju tabeliniai numeriai pagal sodros numer
		f_select("SELECT A.a06_kodas_tb, A.a06_zml_iki FROM " + ;
					"(SELECT a06_kodas_tb, a06_zml_iki, upper(SUBSTRING(a06_sod_nr,1,2)) + CONVERT(char(18),CONVERT(int, SUBSTRING(a06_sod_nr,3,18)))  as a06_sod_nr FROM A06_tab WHERE a06_zml_iki >= ?m.laik) AS A " + ;
					" WHERE a06_sod_nr = ?m.sodra_nr","la06")
		
		IF EOF("la06")
			m.err_msg = m.err_msg + CHR(10) + "Darbuotoj srae nerastas sodros numeris " + m.sodra_nr
			m.duomenys = SUBSTR(m.duomenys,ATC("<Asmuo>",m.duomenys,2))
			LOOP
		ENDIF
		
		SELECT LA06
		GO TOP
		SCAN
			m.tabel = la06.a06_kodas_tb
			m.pap_kint = PADL(ALLTRIM(kodas_lk),12,"0")
			* - jeigu paskutine galiojanti reiksme sutampa su failo reiksme tada neimportuojama
			=f_select("SELECT a02_kodas_tb FROM a02_kinr WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint","ll02")
			
			IF EOF("ll02") AND m.sodra <> 0
				INSERT INTO kint VALUES (m.tabel, m.ak, m.sodra_nr, m.sodra, DTOC(m.laik))			
			ELSE 
				IF FZMO(VAL(kodas_lk), m.laik, m.tabel) <> m.sodra
					* - Tikrinama ar nebuvo vesta konkreciai datai, t.y. jeigu jau buvo importuota u t mnes, bet norima updatinti
					=f_select("SELECT * FROM a02_kinr WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint AND a02_date = ?m.laik","ll02_2")
					IF EOF("ll02_2")
						INSERT INTO kint VALUES (m.tabel, m.ak, m.sodra_nr, m.sodra, DTOC(m.laik))
					ELSE
						=f_select("UPDATE a02_kinr SET a02_suma = ?m.sodra WHERE a02_kodas_tb = ?m.tabel and a02_kodas_lk = ?m.pap_kint AND a02_date = ?m.laik")
						m.err_msg = m.err_msg + CHR(10) + "Tabeliniui " + ALLTRIM(m.tabel) + " buvo atnaujinta " + DTOC(m.laik) + " datai reikm  " + ALLTRIM(STR(m.sodra,10,2))
					ENDIF
				ENDIF
			ENDIF
		ENDSCAN
	endif
	
	m.duomenys = SUBSTR(m.duomenys,ATC("<Asmuo>",m.duomenys,2))
ENDDO

IF USED("la06")
	USE IN la06
endif

=Fclose(ln_handl)

SELECT kint

*******************Kuriamas .eip failas kintamuju reiksmems
IF !EOF("kint")
	ep_failas=tmp_sys()+".eip"
	SET DEFAULT TO (titi_pagr.katalogas)
	if empty(ep_failas)
		return .f.
	endif


	handl=fcreat(ep_failas)
	if handl>0
		SELECT kint
		GO TOP
		SCAN
		
			fputs(handl,'<A02>')
			fputs(handl,'     <A02_KODAS_LK>'+kodas_lk+'</A02_KODAS_LK>')
			fputs(handl,'     <A02_TIPAS>3</A02_TIPAS>')
			fputs(handl,'     <A02_DATE>'+kint.datai+'</A02_DATE>')
			fputs(handl,'     <A02_KODAS_TB>'+kint.kodas_tb+'</A02_KODAS_TB>')
			fputs(handl,'     <A02_SUMA>'+STR(kint.procentas,14,3)+'</A02_SUMA>')
			fputs(handl,'</A02>')

		ENDSCAN

		=fclose(handl)

		titi_pagr.ads_lkr.inf_eii(ep_failas,.f.)	&& importas  kintamu reiksmes
		
		erase (ep_failas)

		wait window nowait l_tek("Importuoti nauji klientai!")
	else
		=l_messagebox("Nepavyko sukurti failo",16,"Eksportas")
		return .f.
	endif
endif

		
IF !EMPTY(m.err_msg)
	m.file_name = tmp_sys()+"err.txt"
	STRTOFILE(m.err_msg, m.file_name)
	showfile(m.file_name)
	erase (m.file_name)
ENDIF

IF USED("la06")
	USE IN la06
ENDIF

return .t.    




